Bug 1270317 - Review Request: lz4-java - LZ4 compression for Java
Review Request: lz4-java - LZ4 compression for Java
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tomas Repik
Fedora Extras Quality Assurance
:
: 1303866 (view as bug list)
Depends On: 1282063
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-09 11:15 EDT by gil cattaneo
Modified: 2016-03-05 01:23 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-05 01:23:17 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
trepik: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description gil cattaneo 2015-10-09 11:15:10 EDT
Spec URL: https://gil.fedorapeople.org/lz4-java.spec
SRPM URL: https://gil.fedorapeople.org/lz4-java-1.3.0-1.fc22.src.rpm
Description:
LZ4 compression for Java, based on Yann Collet's work.
This library provides access to two compression methods
that both generate a valid LZ4 stream:

* fast scan (LZ4):
    ° low memory footprint (~ 16 KB),
    ° very fast (fast scan with skipping heuristics in case the
      input looks incompressible),
    ° reasonable compression ratio (depending on the
      redundancy of the input).
* high compression (LZ4 HC):
    ° medium memory footprint (~ 256 KB),
    ° rather slow (~ 10 times slower than LZ4),
    ° good compression ratio (depending on the size and
      the redundancy of the input).

The streams produced by those 2 compression algorithms use the
same compression format, are very fast to decompress and can be
decompressed by the same decompressor instance

Fedora Account System Username: gil

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=11387051
Comment 1 Upstream Release Monitoring 2015-10-09 15:24:55 EDT
gil's scratch build of lz4-java-1.3.0-1.fc22.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11387051
Comment 3 Tomas Repik 2016-02-08 04:39:58 EST
*** Bug 1303866 has been marked as a duplicate of this bug. ***
Comment 4 Upstream Release Monitoring 2016-02-11 13:38:50 EST
gil's scratch build of lz4-java-1.3.0-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12945998
Comment 5 Tomas Repik 2016-02-15 10:43:49 EST
rmplint results

lz4-java.x86_64: E: no-binary
> add BuildArchitectures: noarch to the SPEC file
lz4-java.x86_64: W: only-non-binary-in-usr-lib
> There are only non binary files in /usr/lib so they should be in /usr/share
> Possibly could just be ignored
lz4-java.src:42: W: unversioned-explicit-provides bundled(libxxhash)
> include a version
Comment 6 gil cattaneo 2016-02-15 12:53:33 EST
(In reply to Tomas Repik from comment #5)
> rmplint results
> 
> lz4-java.x86_64: E: no-binary
> > add BuildArchitectures: noarch to the SPEC file
No, this will never happen
> lz4-java.x86_64: W: only-non-binary-in-usr-lib
> > There are only non binary files in /usr/lib so they should be in /usr/share
> > Possibly could just be ignored
The artifact is installed in /usr/lib/java (%{_jnidir})
see https://fedoraproject.org/wiki/Packaging:Java#Packaging_JAR_files_that_use_JNI
> lz4-java.src:42: W: unversioned-explicit-provides bundled(libxxhash)
> > include a version
is really necessary? i would remove libxxhash stuff when RHBZ#1282063 will be solved
Comment 7 gil cattaneo 2016-02-16 12:57:33 EST
> (In reply to Tomas Repik from comment #5)
> > rmplint results
> > lz4-java.src:42: W: unversioned-explicit-provides bundled(libxxhash)
> > > include a version
Done

Spec URL: https://gil.fedorapeople.org/lz4-java.spec
SRPM URL: https://gil.fedorapeople.org/lz4-java-1.3.0-1.fc23.src.rpm
Comment 8 Tomas Repik 2016-02-18 07:50:05 EST
Now I know why:
> lz4-java.x86_64: E: no-binary
> > add BuildArchitectures: noarch to the SPEC file
> No, this will never happen
> lz4-java.x86_64: W: only-non-binary-in-usr-lib
> > There are only non binary files in /usr/lib so they should be in /usr/share
> > Possibly could just be ignored
> The artifact is installed in /usr/lib/java (%{_jnidir})

The package is really good, only thing is with that bundled xxhash, I don't know if it could be removed later. Here is the review:

Package Review
==============
Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

[?]: Every binary RPM package which stores shared library files (not just
     symlinks) in any of the dynamic linker's default paths, must call
     ldconfig in %post and %postun.
[!]: Package contains no bundled libraries without FPC exception.

Some non-blockers
- no need to remove .jar .class files there are not any
- a typo in the comment on %check section: wast > waste
- no ${libdir} in build.xml ( sed -i 's|${libdir}|%{_libdir}|' build.xml)
- patches should link to upstream bugs/comments/lists

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)", "GPL (v2 or later)", "Unknown or generated",
     "*No copyright* Apache (v2.0)". 8 files have unknown license. Detailed
     output of licensecheck in /home/makerpm/rev/lz4-java/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
     Note: Test run failed
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in lz4
     -java-javadoc
     Javadoc package should not depend on its base package and vice versa.
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Packages are noarch unless they use JNI
     Note: lz4-java subpackage is not noarch. Please verify manually
     Use of JNI
[x]: Package uses upstream build method (ant/maven/etc.)

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: lz4-java-1.3.0-1.fc24.x86_64.rpm
          lz4-java-javadoc-1.3.0-1.fc24.noarch.rpm
          lz4-java-1.3.0-1.fc24.src.rpm
lz4-java.x86_64: W: spelling-error %description -l en_US incompressible -> in compressible, in-compressible, incomprehensible
lz4-java.x86_64: W: spelling-error %description -l en_US decompressor -> decompress or, decompress-or, decompress
lz4-java.x86_64: E: no-binary
lz4-java.x86_64: W: only-non-binary-in-usr-lib
lz4-java.src: W: spelling-error %description -l en_US incompressible -> in compressible, in-compressible, incomprehensible
lz4-java.src: W: spelling-error %description -l en_US decompressor -> decompress or, decompress-or, decompress
3 packages and 0 specfiles checked; 1 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
lz4-java.x86_64: W: spelling-error %description -l en_US incompressible -> in compressible, in-compressible, incomprehensible
lz4-java.x86_64: W: spelling-error %description -l en_US decompressor -> decompress or, decompress-or, decompress
lz4-java.x86_64: E: no-binary
lz4-java.x86_64: W: only-non-binary-in-usr-lib
2 packages and 0 specfiles checked; 1 errors, 3 warnings.



Requires
--------
lz4-java-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

lz4-java (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    lz4(x86-64)



Provides
--------
lz4-java-javadoc:
    lz4-java-javadoc

lz4-java:
    bundled(libxxhash)
    lz4-java
    lz4-java(x86-64)
    mvn(net.jpountz.lz4:lz4)
    mvn(net.jpountz.lz4:lz4:pom:)
    osgi(lz4-java)



Source checksums
----------------
https://github.com/jpountz/lz4-java/archive/1.3.0.tar.gz :
  CHECKSUM(SHA256) this package     : 7fdfe31304a50a830f4f2e8207cdfe58126270e2f24d7c318540e2b263bead78
  CHECKSUM(SHA256) upstream package : 7fdfe31304a50a830f4f2e8207cdfe58126270e2f24d7c318540e2b263bead78


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -P Java,C/C++:off -D EXARCH --rpm-spec -n /home/makerpm/rpmbuild/SRPMS/lz4-java-1.3.0-1.fc23.src.rpm
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: DISTTAG, EPEL5, BATCH, EPEL6
Comment 9 gil cattaneo 2016-02-18 14:31:46 EST
(In reply to Tomas Repik from comment #8)
> Now I know why:
> > lz4-java.x86_64: E: no-binary
> > > add BuildArchitectures: noarch to the SPEC file
> > No, this will never happen

the build depends on the architecture of the system according to the library used (lz4), it is not possible that both noarch

> > lz4-java.x86_64: W: only-non-binary-in-usr-lib
> > > There are only non binary files in /usr/lib so they should be in /usr/share
> > > Possibly could just be ignored
> > The artifact is installed in /usr/lib/java (%{_jnidir})

see https://fedoraproject.org/wiki/Packaging:Java#Packaging_JAR_files_that_use_JNI
and it is all that there is to say / write

> The package is really good, only thing is with that bundled xxhash, I don't
> know if it could be removed later. Here is the review:

see https://fedoraproject.org/w/index.php?title=Packaging:No_Bundled_Libraries&oldid=406058#Requirement_if_you_bundle

> Package Review
> ==============

> 
> [?]: Every binary RPM package which stores shared library files (not just
>      symlinks) in any of the dynamic linker's default paths, must call
>      ldconfig in %post and %postun.

Is no necessary for a JNI library

> [!]: Package contains no bundled libraries without FPC exception.

Is no MORE necessary

> Some non-blockers
> - no need to remove .jar .class files there are not any
Done
> - a typo in the comment on %check section: wast > waste
Done
> - no ${libdir} in build.xml ( sed -i 's|${libdir}|%{_libdir}|' build.xml)

Seriously? What guidelines do you use?
We use only: 
https://fedoraproject.org/wiki/Packaging:Java
https://fedorahosted.org/released/javapackages/doc/

> - patches should link to upstream bugs/comments/lists
Is no necessary, comments are available and the patches are specific only for Fedora


> [!]: Package contains no bundled libraries without FPC exception.
See above

> [?]: Package should compile and build into binary rpms on all supported
>      architectures.
It is already covered
> Java:
> [x]: Packages are noarch unless they use JNI
>      Note: lz4-java subpackage is not noarch. Please verify manually
>      Use of JNI
Comment 10 Tomas Repik 2016-02-22 04:55:55 EST
(In reply to gil cattaneo from comment #9)
> see
> https://fedoraproject.org/w/index.php?title=Packaging:
> No_Bundled_Libraries&oldid=406058#Requirement_if_you_bundle

But you still need the FPC exception right?
Comment 11 gil cattaneo 2016-02-22 13:06:38 EST
(In reply to Tomas Repik from comment #10)
> (In reply to gil cattaneo from comment #9)
> > see
> > https://fedoraproject.org/w/index.php?title=Packaging:
> > No_Bundled_Libraries&oldid=406058#Requirement_if_you_bundle
> 
> But you still need the FPC exception right?

The guideline was recently changed ...
Open FPC ticket (Bundled Library Exception) https://fedorahosted.org/fpc/ticket/603
Comment 12 gil cattaneo 2016-02-22 13:29:08 EST
FPC ticket was closed:
Resolution:  nothingtodo
"
Comment:

 FPC no longer has anything to do with bundling.  Please see the current
 guidelines:

 https://fedoraproject.org/wiki/Packaging:Guidelines#Bundling_and_Duplication_of_system_libraries

 Please make sure to add the necessary "Provides: bundled(xxHash) =
 version" to your package.
"
Comment 13 Tomas Repik 2016-02-23 05:57:03 EST
All right, I've already (accidentally) set the fedora-review flag to "+" so the package is ready to proceed to next phase.
I would just include the link to the FPC ticket in the spec file anyway.
Thank you.
Comment 14 Gwyn Ciesla 2016-02-24 08:33:57 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/lz4-java
Comment 15 Fedora Update System 2016-02-24 15:59:44 EST
lz4-java-1.3.0-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-7c436d5d72
Comment 16 Fedora Update System 2016-02-25 21:23:55 EST
lz4-java-1.3.0-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-7c436d5d72
Comment 17 Fedora Update System 2016-03-05 01:23:14 EST
lz4-java-1.3.0-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.